package com.huigou.topsun.customer.application.Impl;

import com.huigou.topsun.customer.application.SapCustomerApplication;
import com.huigou.topsun.customer.domain.CustomerContact;
import com.huigou.topsun.customer.domain.dto.SapCustomerDto;
import com.huigou.topsun.customer.domain.vo.CustomerVo;
import com.huigou.uasp.bmp.common.application.AbstractApplication;
import org.springframework.stereotype.Service;

import java.util.Date;

@Service
public class SapCustomerApplicationImpl extends AbstractApplication implements SapCustomerApplication {

    @Override
    public SapCustomerDto submitCustomerToSAP(CustomerVo customerVo, CustomerContact customerContact) {
        SapCustomerDto sapCustomerDto = new SapCustomerDto();

        //账目组
//        customerDto.setBU_GROUP();

        //sap：客户编号customerCode 金库：客户编码KUNNR
//        customerDto.setKUNNR();

        //业务伙伴角色
//        customerDto.setPLTYP();

        //客户名称
        String customerName = customerVo.getCustomerName();
        sapCustomerDto.setNAME1(customerName);

        //客户简称
        String customerShortName = customerVo.getCustomerShortName();
        sapCustomerDto.setBU_SORT(customerShortName);

        //收货地址
        String customerAddress = customerVo.getCustomerAddress();
        sapCustomerDto.setSTRAS(customerAddress);

        //客户送货地址（固定）
//        customerDto.setSTR_SUPPL3();

        //城市
        String city = customerVo.getCity();
        sapCustomerDto.setCITY1(city);

        //国家
//        customerDto.setLAND1();

        //地区
        String province = customerVo.getProvince();
        String region = province + city;
        sapCustomerDto.setREGIO(region);

        //语言
//        customerDto.setSPRAS();

        //邮政编码
        String customerZipCode = customerVo.getCustomerZipCode();
        sapCustomerDto.setPOST_CODE1(customerZipCode);

        //公司电话号码
//        customerDto.setTELF1();

        //公司移动电话
//        customerDto.setTEL_NUMBER();

        //公司传真
//        customerDto.setTELFX();

        //公司邮箱
//        customerDto.setSMTP_ADDR();

        //开户银行代码（？）
        String customerBankId = customerVo.getCustomerBankId();
        sapCustomerDto.setBANKL(customerBankId);

        //银行账号
        String customerAccountNo = customerVo.getCustomerAccountNo();
        sapCustomerDto.setBANKN(customerAccountNo);

        //做账难度等级
        String accountDifficultLevel = customerVo.getAccountDifficultLevel();
        sapCustomerDto.setKUKLA(accountDifficultLevel);

        //要求用客户系统货单（是、否）
        String customerSysOrder = customerVo.getCustomerSysOrder();
        sapCustomerDto.setKATR1(customerSysOrder);

        //盖章方式（传key）
        String stampMethod = customerVo.getStampMethod();
        sapCustomerDto.setKATR2(stampMethod);

        //请款联（传key，key是sap字典的数字编码）
        String paymentRequestForm = customerVo.getPaymentRequestForm();
        sapCustomerDto.setKATR3(paymentRequestForm);

        //客户联（传key，key是sap字典的数字编码）
        String customerReceipt = customerVo.getCustomerReceipt();
        sapCustomerDto.setKATR4(customerReceipt);

        //订单要求（sap数据字典）
        String orderRequire = customerVo.getOrderRequire();
        sapCustomerDto.setKATR5(orderRequire);

        //验收单要求（sap数据字典）
        String acceptanceRequire = customerVo.getAcceptanceRequire();
        sapCustomerDto.setKATR6(acceptanceRequire);

        //客户系统验收要求（）
        String customerSysAcceptanceRequire = customerVo.getCustomerSysAcceptanceRequire();
        sapCustomerDto.setKATR7(customerSysAcceptanceRequire);

        //要求签回货单
        String signedBack = customerVo.getSignedBack();
        sapCustomerDto.setKATR8(signedBack);

        //货单是否打印送货日期
        String isPrintDeliveryDate = customerVo.getIsPrintDeliveryDate();
        sapCustomerDto.setKATR9(isPrintDeliveryDate);

        //不开发票
        String needInvoice = customerVo.getNeedInvoice();
        sapCustomerDto.setKATR10(needInvoice);

        //请款要求
        String paymentRequest = customerVo.getPaymentRequest();
        sapCustomerDto.setZT01(paymentRequest);

        //客户工作时间
        Date customerWorkTime = customerVo.getCustomerWorkTime();
        sapCustomerDto.setZT02(String.valueOf(customerWorkTime));

        //收货方签字要求
        String receiverSignatureRequire = customerVo.getReceiverSignatureRequire();
        sapCustomerDto.setZT03(receiverSignatureRequire);

        //货单打印要求
        String shipPrintRequire = customerVo.getShipPrintRequire();
        sapCustomerDto.setZT04(shipPrintRequire);

        //品牌
        String customerBrand = customerVo.getCustomerBrand();
        sapCustomerDto.setZF01(customerBrand);

        //职位
        String contactPosition = customerContact.getContactPosition();
        sapCustomerDto.setZF02(contactPosition);

        //联系人
        String contactName = customerContact.getContactName();
        sapCustomerDto.setZF03(contactName);

        //电话号码
        String contactPhone = customerContact.getContactPhone();
        sapCustomerDto.setZF04(contactPhone);

        //e_Mail
        String contactEmail = customerContact.getContactEmail();
        sapCustomerDto.setZF05(contactEmail);

        //经营类型
//        customerDto.setZF06();

        //工厂代号
        String customerFactoryCode = customerVo.getCustomerFactoryCode();
        sapCustomerDto.setZF07(customerFactoryCode);

        //产品检验报告类型
        String productInspectionReportType = customerVo.getProductInspectionReportType();
        sapCustomerDto.setZF08(productInspectionReportType);

        //货单签回方式
        String signedStyle = customerVo.getSignedStyle();
        sapCustomerDto.setZF09(signedStyle);

        //出货方式
        String shipMethod = customerVo.getShipMethod();
        sapCustomerDto.setZF10(shipMethod);

        //路线
        String route = customerVo.getRoute();
        sapCustomerDto.setZF11(route);

        //送货单打印默认设置
//        customerDto.setZF12();

        //送货单统计异常期限
        Integer shipAbnormalDeadline = customerVo.getShipAbnormalDeadline();
        sapCustomerDto.setZF13(String.valueOf(shipAbnormalDeadline));

        //生产发货方式
        String productionDeliveryMethod = customerVo.getProductionDeliveryMethod();
        sapCustomerDto.setZF14(productionDeliveryMethod);

        //月结方式
        String monthlySettlementMethod = customerVo.getMonthlySettlementMethod();
        sapCustomerDto.setZF15(monthlySettlementMethod);

        //请款期限
        Integer paymentDeadline = customerVo.getPaymentDeadline();
        sapCustomerDto.setZF16(String.valueOf(paymentDeadline));

        //做账截止日
        Integer accountDeadline = customerVo.getAccountDeadline();
        sapCustomerDto.setZF17(String.valueOf(accountDeadline));

        //客户收账截止日
        Integer customerCollectionDeadline = customerVo.getCustomerCollectionDeadline();
        sapCustomerDto.setZF18(String.valueOf(customerCollectionDeadline));

        //订单统计异常期限
        Integer orderAbnormalDeadline = customerVo.getOrderAbnormalDeadline();
        sapCustomerDto.setZF19(String.valueOf(orderAbnormalDeadline));

        //公司代码
//        customerDto.setBUKRS();

        //统驭科目
//        customerDto.setAKONT();

        //销售组织
//        customerDto.setVKORG();

        //分销渠道
//        customerDto.setVTWEG();

        //产品组
//        customerDto.setSPART();

        //客户组
//        customerDto.setKDGRP();

        //销售办公室
//        customerDto.setVKBUR();

        //销售小组
//        customerDto.setVKGRP();

        //客户分类
//        customerDto.setKLABC();

        //币别
        String quotationCurrency = customerVo.getQuotationCurrency();
        sapCustomerDto.setWAERS(quotationCurrency);

        //汇率类型
//        customerDto.setKURST();

        //价格清单
//        customerDto.setPLTYP();

        //国际贸易条款
//        customerDto.setINCO1();

        //国际贸易条款位置
//        customerDto.setINCO2();

        //付款条件
//        customerDto.setZTERM();

        //客户科目分配组
//        customerDto.setKTGRD();

        //税收类别
//        customerDto.setTATYP();

        //客户税分类
//        customerDto.setTAXKD();
        return sapCustomerDto;
    }
}
