package com.huigou.topsun.product.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.huigou.topsun.common.NumberToStringSerializer;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author YourUserName
 * 产品物料组成
 */
@JsonInclude(JsonInclude.Include.ALWAYS)
@JsonIgnoreProperties(ignoreUnknown = true)
@Entity
@Table(name = "product_material")
public class ProductMaterial implements Serializable {

	/**
	 * 产品物料组成ID
	 */
	@Id
	//@JsonSerialize(using = NumberToStringSerializer.class)
	@GeneratedValue(generator = "system-uuid")
	@GenericGenerator(name = "system-uuid", strategy = "guid")
	@Column(name = "product_material_id", nullable = false)
	private String productMaterialId;

	/**
	 * 产品ID
	 */
	//@JsonSerialize(using = NumberToStringSerializer.class)
	@Column(name = "product_id", nullable = true)
	private String productId;

	/**
	 * 物料ID
	 */
	@Column(name = "material_id", nullable = true, length = 32)
	private String materialId;
	/**
	 * 物料编码
	 */
	@Column(name = "material_code", nullable = true, length = 32)
	private String materialCode;
	/**
	 * 物料名称
	 */
	@Column(name = "material_name", nullable = true, length = 32)
	private String materialName;

	/**
	 * 物料数量
	 */
	@Column(name = "material_number", nullable = true)
	private Integer materialNumber;

	/**
	 * BOM版本
	 */
	@Column(name = "bom_version", nullable = true, length = 128)
	private String bomVersion;

	/**
	 * 产品BOM类型(bom_type)
	 */
	@Column(name = "bom_type", nullable = true, length = 32)
	private String bomType;

	public String getMaterialCode() {
		return materialCode;
	}

	public void setMaterialCode(String materialCode) {
		this.materialCode = materialCode;
	}

	public String getMaterialName() {
		return materialName;
	}

	public void setMaterialName(String materialName) {
		this.materialName = materialName;
	}

	public String getProductMaterialId() {
		return this.productMaterialId;
	}
	
	public void setProductMaterialId (String  productMaterialId) {
		this.productMaterialId = productMaterialId;
	}
	
	public String getProductId() {
		return this.productId;
	}
	
	public void setProductId (String  productId) {
		this.productId = productId;
	}
	
	public String getMaterialId() {
		return this.materialId;
	}
	
	public void setMaterialId(String materialId) {
		this.materialId = materialId;
	}
	
	public Integer getMaterialNumber() {
		return this.materialNumber;
	}
	
	public void setMaterialNumber(Integer materialNumber) {
		this.materialNumber = materialNumber;
	}
	
	public String getBomVersion() {
		return this.bomVersion;
	}
	
	public void setBomVersion(String bomVersion) {
		this.bomVersion = bomVersion;
	}
	
	public String getBomType() {
		return this.bomType;
	}
	
	public void setBomType(String bomType) {
		this.bomType = bomType;
	}
}
